package com.jianziqiang.serviceboard.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.jianziqiang.commonutils.JwtUtils;
import com.jianziqiang.commonutils.R;
import com.jianziqiang.serviceboard.entity.Admin;
import com.jianziqiang.serviceboard.entity.Board;
import com.jianziqiang.serviceboard.service.AdminService;
import com.jianziqiang.serviceboard.service.BoardService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * @Author xiubao
 * @Date 2022/8/24 8:35
 * @PackageName： com.jianziqiang.serviceboard.controller
 * @ClassName: AdminController
 * @Version 1.0
 */
@RequestMapping("admin")
@RestController
@CrossOrigin
public class AdminController {
    @Autowired
    private AdminService adminService;
    @Autowired
    private BoardService boardService;

    @PostMapping("login")
    public R login(@RequestBody Admin admin) throws Exception {
        String username = admin.getUsername();
        String password = admin.getPassword();
        if (StringUtils.isEmpty(username) || StringUtils.isEmpty(password)) {
            throw new Exception("用户名或密码不能为空!");
        }
        //判断用户是否存在
        QueryWrapper<Admin> adminQueryWrapper = new QueryWrapper<>();
        adminQueryWrapper.eq("username", username);
        Admin record = adminService.getOne(adminQueryWrapper);
        if (record == null) {
            throw new Exception("用户名或密码错误，请重新输入！");
        }
        if (!password.equals(record.getPassword())) {
            throw new Exception("用户名或密码错误，请重新输入！");
        }
        String token = JwtUtils.getJwtToken(String.valueOf(record.getId()), record.getUsername());
        return R.ok().data("token", token);
    }

    @GetMapping("listEmail")
    public R listEmail() {
        List<Board> list = boardService.list(null);
        return R.ok().data("list", list);
    }
}
