package com.jianziqiang.serviceboard.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jianziqiang.commonutils.EmailUtil;
import com.jianziqiang.serviceboard.entity.Board;
import com.jianziqiang.serviceboard.mapper.BoardMapper;
import com.jianziqiang.serviceboard.query.BoardQuery;
import com.jianziqiang.serviceboard.service.BoardService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author BaseBoard
 * @since 2022-07-28
 */
@Service
public class BoardServiceImpl extends ServiceImpl<BoardMapper, Board> implements BoardService {

    @Autowired
    private EmailUtil util;

    @Override
    public void pageQuery(Page<Board> pageParam, BoardQuery query) {
        QueryWrapper<Board> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByAsc("id");
        if (query == null){
            baseMapper.selectPage(pageParam, queryWrapper);
            return;
        }
        String name = query.getNickName();
        String begin = query.getBegin();
        String end = query.getEnd();
        if (!StringUtils.isEmpty(name)) {
            queryWrapper.like("name", name);
        }
        if (!StringUtils.isEmpty(begin)) {
            queryWrapper.ge("create_time", begin);
        }
        if (!StringUtils.isEmpty(end)) {
            queryWrapper.le("create_time", end);
        }
        baseMapper.selectPage(pageParam, queryWrapper);
    }

    @Override
    public boolean sendEmail(Board board) {

        String text = "留言者填的称呼：" + board.getNickName() + "\n留言者填的联系方式：" + board.getContract() +
                "\n留言者的留言内容:" + board.getMessage() + "\n留言时间:" + new Date();
        String goal = "hi@qiql.net";
        String subject = "网站有了新的留言";
        return util.sendMail(goal,subject,text);
    }
}
